#ifndef CLICK_PSHASH_HH
#define CLICK_PSHASH_HH
#include <click/element.hh>
#include <click/atomic.hh>
#include "psclassify.hh"
CLICK_DECLS

/*
=c

PSHash(OFFSET, SIZE)

=s pubsub

Calculates hash suitable for PSCache element. Sets the result in packet's annotations.

=d

Hash is calculated from the OFFSET of the beginning of the packet, and SIZE consequtive
bytes are used.

The hash result value is added to packet's annotations, otherwise packet is not modified.

*/
class PSHash : public Element { 
public:
    
    PSHash();
    ~PSHash();
    
    const char *class_name() const		{ return "PSHash"; }
    const char *port_count() const		{ return "1/1"; }
    const char *processing() const		{ return "h/h"; }
    const char *flow_code() const               { return "x/x"; }

    int configure(Vector<String> &, ErrorHandler *);
    void push(int, Packet *);
private:

    unsigned int _off, _size;
  unsigned int myhash;
};

CLICK_ENDDECLS
#endif
