#ifndef CLICK_PSLOAD_HH
#define CLICK_PSLOAD_HH
#include <click/element.hh>
#include <click/atomic.hh>
#include "pscheck.hh"
#include "pscache.hh"
CLICK_DECLS

/*
=c

PSHash(OFFSET, SIZE)

=s pubsub

Calculates hash suitable for PSCache element. Sets the result in packet's annotations.

=d

Hash is calculated from the OFFSET of the beginning of the packet, and SIZE consequtive
bytes are used.

The hash result value is added to packet's annotations, otherwise packet is not modified.

*/
class PSLoad : public Element { 
public:
    
    PSLoad();
    ~PSLoad();
    
    const char *class_name() const		{ return "PSLoad"; }
    const char *port_count() const		{ return "1/2"; }
    const char *processing() const		{ return "h/h"; }
    const char *flow_code() const               { return "x/xy"; }

    int configure(Vector<String> &, ErrorHandler *);
    void push(int, Packet *);
private:
    PSCache *_cache;
};

CLICK_ENDDECLS
#endif
