#include <click/config.h>
#include <click/confparse.hh>
#include <click/error.hh>
#include "pscheck.hh"
#include "psstore.hh"
#include "pscache.hh"
CLICK_DECLS

/* Packetcache
 *
 * Configuration: 
 *
 *
 */

PSStore::PSStore()
{
}

PSStore::~PSStore()
{
}

int PSStore::configure(Vector<String> &conf, ErrorHandler *errh)
{
    Element *temp;

    if (conf.size() < 1) {
	return errh->error("Cache missing");
    }

    temp = cp_element(conf.at(0), this, errh);
    if (!temp) {
	return errh->error("Could not parse PSCache element");
    }

    _cache = (PSCache *)temp->cast("PSCache");
    if (!_cache) {
	return errh->error("Parsed element not PSCache");
    }

    return 0;
}

void PSStore::push(int, Packet *p) 
{
    unsigned int hashvalue = p->anno_u32(PS_ANNO_HASHVALUE);

    _cache->store(hashvalue, p->data(), p->length());

#if 0
    String debugstr = _cache->print();
    click_chatter("%s", debugstr.c_str());
#endif
    output(0).push(p);
    return;
}

CLICK_ENDDECLS
ELEMENT_REQUIRES(PSCache)
EXPORT_ELEMENT(PSStore)
